SystemOrganization addCategory: #'Smallchange-Core'!
SystemOrganization addCategory: #'Smallchange-Core-Commands'!

!Number methodsFor: '*smallchange-core' stamp: 'StuartHerring 12/11/2011 11:28'!
printAsCurrency
	| s|
	s := WriteStream with: ''.
	self printOn: s showingDecimalPlaces: 2.
	^s contents! !

MbObject subclass: #ScObject
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScObject class methodsFor: 'instance creation' stamp: 'StuartHerring 12/11/2011 14:19'!
profile: aProfile
	^self basicNew
		initializeWithProfile: aProfile;
		yourself.! !

!ScObject methodsFor: 'initialization' stamp: 'StuartHerring 12/11/2011 14:20'!
initializeWithProfile: aProfile
	self initialize.
	profile := aProfile! !

ScObject subclass: #ScSchedule
	instanceVariableNames: 'start interval count transaction name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:44'!
addDaysTo: aDate
	^aDate addDays: count.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 20:16'!
addMonthsTo: aDate
	^aDate addMonths: count asInteger.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:42'!
addTo: aDate
	| symbol |
	symbol := ('add{1}sTo:' format: { interval capitalized}) asSymbol.
	^self perform: symbol with: aDate! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:44'!
addWeeksTo: aDate
	^aDate addDays: count * 7.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:43'!
addYearsTo: aDate
	^aDate addMonths: count * 12.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:49'!
count
	<required>
	<integer>
	^count	! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 13:51'!
count: aNumber
	self set: #count to: aNumber.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:56'!
datesBetween: rangeStart and: rangeEnd
	| dates currentDate |
	dates := OrderedCollection new.
	currentDate := self nextAfter: rangeStart.
	[ currentDate > rangeEnd ] whileFalse: [
		dates add: currentDate.
		currentDate := self addTo: currentDate].
	^dates! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:26'!
initializeWithProfile: aProfile
	<mbFields: #(name start interval count transaction)>
	super initializeWithProfile: aProfile.
	transaction := ScTransaction profile: profile.
	count := 1.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/6/2012 14:12'!
interval
	<valueSelector: #intervalTypes>
	<required>
	^interval! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 10:15'!
interval: aSymbol
	self set: #interval to: aSymbol! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 13:49'!
intervalTypes
	^#(day week month year)! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:56'!
name
	^name! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:57'!
name: aString
	self set: #name to: aString! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:50'!
nextAfter: aDate
	| newDate |
	newDate := start.
	[ newDate > aDate ] whileFalse: [ newDate := self addTo: newDate ].
	^newDate
	! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:48'!
nextDate
	^self nextAfter: Date current.! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 10:13'!
start
	<date>
	<required>
	^start! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 10:14'!
start: aDate
	self set: #start to: aDate! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:54'!
transaction
	<required>
	^transaction! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 13:51'!
transaction: aTransactionTemplate
	self set: #transaction to: aTransactionTemplate! !

!ScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:54'!
transactionsBetween: rangeStart and: rangeEnd
	^(self datesBetween: rangeStart and: rangeEnd)
		select: [ :d | d > rangeStart]
		thenCollect: [ :d | transaction copy date: d ]! !

ScObject subclass: #ScTransaction
	instanceVariableNames: 'comment amount date sourcePool sourceAccount pool account completed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScTransaction subclass: #ScExpense
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScExpense methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 13:00'!
account
	<readOnly>
	^nil! !

!ScExpense methodsFor: 'testing' stamp: 'StuartHerring 3/4/2012 19:21'!
initialize 
	<mbFields: #(sourcePool amount comment date sourceAccount )>
	super initialize.
! !

!ScExpense methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:17'!
isExpense
	^true! !

!ScExpense methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:17'!
isIncome
	^false! !

!ScExpense methodsFor: 'testing' stamp: 'StuartHerring 2/25/2012 13:59'!
isTransfer
	^false! !

!ScExpense methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 13:00'!
pool
	<readOnly>
	^nil! !

!ScExpense methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 15:19'!
printOn: aStream
	aStream nextPutAll:  'Spent ';
		nextPutAll: '$'; 
		nextPutAll: amount printAsCurrency;
		nextPutAll: ' on ';
		nextPutAll: (sourcePool ifNil: [ 'Unallocated' ] ifNotNil: [ :p | p name ]);
		nextPutAll: ' from ';
		nextPutAll: sourceAccount name. ! !

ScTransaction subclass: #ScIncome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScIncome methodsFor: 'testing' stamp: 'StuartHerring 3/4/2012 19:21'!
initialize 
	<mbFields: #(pool amount comment date account )>
	super initialize.
! !

!ScIncome methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:17'!
isExpense
	^false! !

!ScIncome methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:15'!
isIncome
	^true! !

!ScIncome methodsFor: 'testing' stamp: 'StuartHerring 2/25/2012 13:59'!
isTransfer
	^false! !

!ScIncome methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 15:20'!
printIncomeOn: aStream
	aStream nextPutAll: 'Received $';
		nextPutAll: amount printAsCurrency;
		nextPutAll: ' for ';
		nextPutAll: (pool ifNil: [ 'Unallocated' ] ifNotNil: [ :p | p name ]);
		nextPutAll: ' in ';
		nextPutAll: account name. ! !

!ScIncome methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 13:00'!
sourceAccount
	<readOnly>
	^nil! !

!ScIncome methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 13:00'!
sourcePool
	<readOnly>
	^nil! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:20'!
account
	<valueSelector: #accountList>
	<required>
	^account! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
account: anAccount
	self set: #account to: anAccount! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/29/2012 10:43'!
accountList
	^profile accounts! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
amount
	<required>
	<currency: $$>
	^amount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
amount: anAmount
	self set: #amount to: anAmount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 15:06'!
comment
	^comment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
comment: aComment
	self set: #comment to: aComment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
date
	<date>
	^date! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
date: aDateAndTime
	self set: #date to: aDateAndTime! !

!ScTransaction methodsFor: 'initialization' stamp: 'StuartHerring 3/3/2012 21:53'!
initialize
	<mbFields: #(sourcePool sourceAccount amount comment pool account date)>
	super initialize.
	date := Date today.
	amount := 0.! !

!ScTransaction methodsFor: 'testing' stamp: 'StuartHerring 2/25/2012 14:01'!
isAllocation
	^self isIncome not & self isExpense not & (pool = sourcePool) not! !

!ScTransaction methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:15'!
isExpense
	^account isNil! !

!ScTransaction methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:15'!
isIncome
	^sourceAccount isNil! !

!ScTransaction methodsFor: 'testing' stamp: 'StuartHerring 2/15/2012 07:16'!
isTransfer
	^self isIncome not & self isExpense not & (account = sourceAccount) not! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:31'!
pool
	<valueSelector: #poolList>
	^pool! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
pool: aPool
	self set: #pool to: aPool! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/30/2012 18:31'!
poolList
	^profile pools! !

!ScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 15:20'!
printOn: aStream
	| allocate transfer |
	transfer := (sourceAccount = account) not.
	allocate := (sourcePool = pool) not.
	allocate ifTrue: [ 
		aStream nextPutAll: 'Allocated '.
		transfer ifTrue: [aStream nextPutAll: ' and ']
	].
	transfer ifTrue: [ aStream nextPutAll: 'Transfered '].
	aStream nextPutAll: '$'; 
		nextPutAll: amount printAsCurrency.
	(allocate & transfer not) | (transfer & allocate not) ifFalse: [
		aStream 
			nextPutAll: ' from '.
	
	allocate ifTrue: [ aStream nextPutAll: (sourcePool ifNil: [ 'Unallocated' ] ifNotNil: [ :p | p name ]).
		transfer ifTrue: [aStream nextPutAll: ' in '] ].
	transfer ifTrue: [ aStream nextPutAll: sourceAccount name ]].

	aStream nextPutAll: ' to '.
	allocate ifTrue: [ aStream nextPutAll: (pool ifNil: [ 'Unallocated' ] ifNotNil: [ :p | p name ]).
		transfer ifTrue: [aStream nextPutAll: ' in '] ].
	transfer ifTrue: [ aStream nextPutAll: account name ].
	! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 07:13'!
sourceAccount
	<valueSelector: #accountList>
	<required>
	^sourceAccount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 07:13'!
sourceAccount: anAccount
	self set: #sourceAccount to: anAccount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 07:13'!
sourcePool
	<valueSelector: #poolList>
	^sourcePool! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 07:14'!
sourcePool: aPool
	self set: #sourcePool to: aPool! !

ScObject subclass: #ScTransactionHolder
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScTransactionHolder subclass: #ScAccount
	instanceVariableNames: 'openingBalance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 3/5/2012 20:38'!
accumulate: aTransaction
	^((aTransaction sourceAccount = aTransaction account) or: [ (self ownsTransaction: aTransaction) not]) ifTrue: [0]
		ifFalse: [
			(aTransaction account = self) 
				ifTrue: [aTransaction amount]
				ifFalse: [aTransaction amount negated]]! !

!ScAccount methodsFor: 'initialization' stamp: 'StuartHerring 3/3/2012 21:54'!
initialize
	<mbFields: #(name openingBalance)>
	super initialize.
	openingBalance := 0.! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:56'!
openingBalance
	<label: 'Opening Balance'>
	<currency: $$>
	<required>
	^openingBalance! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:55'!
openingBalance: anAmount
	openingBalance := anAmount.! !

!ScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/3/2012 13:48'!
ownsTransaction: t
	^t account = self xor: (t sourceAccount = self)! !

ScTransactionHolder subclass: #ScPool
	instanceVariableNames: 'defaultAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScPool methodsFor: 'constraints' stamp: 'StuartHerring 2/7/2012 21:47'!
accountList
	^profile accounts! !

!ScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 20:38'!
accumulate: aTransaction
	^((aTransaction sourcePool = aTransaction pool) or: [ (self ownsTransaction: aTransaction) not]) ifTrue: [0]
		ifFalse: [
			(aTransaction pool = self) 
				ifTrue: [aTransaction amount]
				ifFalse: [aTransaction amount negated]]! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:50'!
defaultAccount
	<required>
	<valueSelector: #accountList>
	^defaultAccount! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:48'!
defaultAccount: anAccount
	self set: #defaultAccount to: anAccount! !

!ScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/3/2012 21:55'!
initialize
	<mbFields: #(name defaultAccount)>
	super initialize.! !

!ScPool methodsFor: 'testing' stamp: 'StuartHerring 3/3/2012 13:48'!
ownsTransaction: t
	^t pool = self xor: (t sourcePool = self)! !

!ScTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 13:20'!
accumulate: aTransaction
	"Return the amount to add or subtract from the balance for this transaction"
	self subclassResponsibility! !

!ScTransactionHolder methodsFor: 'printing' stamp: 'StuartHerring 2/7/2012 21:45'!
asString
	^name! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 13:23'!
balance
	<ignore>
	^self transactions inject: self openingBalance into: [ :total :this | total + (self accumulate: this) ]! !

!ScTransactionHolder methodsFor: 'initialization' stamp: 'StuartHerring 3/3/2012 21:54'!
initialize
	<mbFields: #(name)>
	super initialize.
	name := ''! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:45'!
name
	<label: 'Name'>
	<required>
	^name! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:46'!
name: aName
	name := aName! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:57'!
openingBalance
	<ignore>
	^0! !

!ScTransactionHolder methodsFor: 'testing' stamp: 'StuartHerring 2/14/2012 16:25'!
ownsTransaction: t
	^false! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/14/2012 16:26'!
transactions
	<ignore>
		^profile transactions select: [ :t | self ownsTransaction: t ]! !

MbCommand subclass: #ScModelCommand
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

ScModelCommand subclass: #ScAddAccount
	instanceVariableNames: 'account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddAccount class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:30'!
profile: aProfile account: anAccount
	^self new
		profile: aProfile;
		account: anAccount;
		yourself.! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:29'!
account: anAccount
	account := anAccount! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:30'!
do
	profile addAccount: account! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:33'!
printOn: aStream
	aStream nextPutAll: 'Added account named ';
		nextPutAll: account name.! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:31'!
undo
	profile removeAccount: account! !

ScModelCommand subclass: #ScAddPool
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddPool class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:31'!
profile: aProfile pool: aPool
	^self new
		profile: aProfile;
		pool: aPool;
		yourself.! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
do
	profile addPool: pool! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
pool: aPool
	pool := aPool! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:33'!
printOn: aStream
	aStream nextPutAll: 'Added pool named ';
		nextPutAll: pool name.! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
undo
	profile removePool: pool! !

ScModelCommand subclass: #ScAddSchedule
	instanceVariableNames: 'schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddSchedule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:15'!
profile: aProfile schedule: aSchedule
	^self new
		profile: aProfile;
		schedule: aSchedule;
		yourself.! !

!ScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:16'!
do
	profile addSchedule: schedule! !

!ScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:16'!
printOn: aStream
	aStream nextPutAll: 'Added schedule named ';
		nextPutAll: schedule name.! !

!ScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:16'!
schedule: aSchedule
	schedule := aSchedule! !

!ScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:17'!
undo
	profile removeSchedule: schedule! !

!ScModelCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:28'!
profile: aProfile
	profile := aProfile! !

ScModelCommand subclass: #ScRecordTransaction
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScRecordTransaction class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:29'!
profile: aProfile transaction: aTransaction
	^self new
		profile: aProfile; transaction: aTransaction;
		yourself! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:08'!
do
	profile addTransaction: transaction.! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 18:55'!
printOn: aStream
	transaction ifNotNil: [ :t | t printOn: aStream]! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:28'!
transaction: aTransaction
	transaction := aTransaction.! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:09'!
undo
	profile removeTransaction: transaction.! !

Object subclass: #ScProfile
	instanceVariableNames: 'name pools accounts recurringTransactions transactions primaryIncome schedules checkpoint pendingTransactions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScProfile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:26'!
name: aName
	^self basicNew
		initializeWithName: aName;
		yourself.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:14'!
accounts
	^accounts! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:20'!
addAccount: anAccount
	(accounts anySatisfy: [ :p | p name = anAccount name]) 
		ifTrue: [ MbValidationError signal: 'An account with the name ', anAccount name, ' already exists' ].
	accounts add: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:19'!
addPool: aPool
	(pools anySatisfy: [ :p | p name = aPool name]) 
		ifTrue: [ MbValidationError signal: 'A pool with the name ', aPool name, ' already exists' ].
	pools add: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 3/4/2012 17:05'!
addSchedule: aSchedule
	(schedules anySatisfy: [ :s | s name = aSchedule name]) 
		ifTrue: [ MbValidationError signal: 'A schedule with the name ', aSchedule name, ' already exists' ].
	schedules add: aSchedule! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 12/11/2011 15:45'!
addTransaction: aTransaction
	transactions add: aTransaction! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 3/10/2012 08:53'!
checkpointDate
	^checkpoint! !

!ScProfile methodsFor: 'initialization' stamp: 'StuartHerring 3/10/2012 09:52'!
initializeWithName: aName
	self initialize.
	name := aName.
	pools := OrderedCollection new.
	accounts := OrderedCollection new.
	recurringTransactions := OrderedCollection new.
	transactions := OrderedCollection new.
	schedules := OrderedCollection new.
	primaryIncome := nil.
	checkpoint := Date today.
	pendingTransactions := Dictionary new.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:07'!
name
	^name! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newAccount
	^ScAccount profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 2/15/2012 13:03'!
newExpense
	^ScExpense profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 2/15/2012 13:03'!
newIncome
	^ScIncome profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newPool
	^ScPool profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 3/4/2012 17:02'!
newSchedule
	^ScSchedule profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newTransaction
	^ScTransaction profile: self! !

!ScProfile methodsFor: 'initialization' stamp: 'StuartHerring 3/10/2012 08:53'!
pendingTransactions
	^pendingTransactions! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 10:52'!
pools
	^pools! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:19'!
removeAccount: anAccount
	accounts remove: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:20'!
removePool: aPool
	pools remove: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 3/4/2012 17:04'!
removeSchedule: aSchedule
	schedules remove: aSchedule! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 20:57'!
removeTransaction: aTransaction
	transactions remove: aTransaction! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 3/4/2012 17:04'!
schedules
	^schedules! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 2/14/2012 16:07'!
transactions
	^transactions! !

!ScProfile methodsFor: 'initialization' stamp: 'StuartHerring 3/10/2012 09:54'!
updatePending
	| today |
	today := Date today.
	schedules do: [ :s | (pendingTransactions at: s ifAbsent: [ pendingTransactions at: s put: OrderedCollection new ]) 
		addAll: (s transactionsBetween:  checkpoint and: today) ].
	checkpoint := today! !
